/*!\file:  Result.h
 * \brief abstract class for Result object
 */ 


#ifndef _RESULT_H_
#define _RESULT_H_

/*Headers:*/
/*{{{1*/
#include "../Object.h"
/*}}}*/

class Result{

	public: 
		
		virtual        ~Result(){};
		
		virtual Result* SpawnSingResult(int  index)=0;
		virtual Result* SpawnBeamResult(int* indices)=0;
		virtual Result* SpawnTriaResult(int* indices)=0;
		virtual void    ProcessUnits(Parameters* parameters)=0;
		virtual int     NumberOfNodalValues(void)=0;
		virtual void    PatchFill(int row, Patch* patch)=0;

};


void NodalValuesUnitConversion(double* nodal_values, int num_nodal_values,int enum_type,Parameters* parameters);
#endif
